<?php
/***************************************************************************
 *                             chess_viewtopic.php
 *                      ---------------------------------
 *   begin                : Saturday, April 8, 2006
 *   copyright            : (C) 2006 M. Yahya, boo.ifreepages.com 
 *   email                : mr.boo@telkom,net
 *
 *   $Id: chess_viewtopic.php,v 0.0.1 2006/4/16 20:00:00 M. Yahya Exp $
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

if ( !defined('IN_PHPBB') )
{
	die("Hacking attempt");
}

function chess_viewtopic_select()
{
	global $count_sql;

	$count_sql = ', t.topic_chess, f.auth_chess_create, f.auth_chess_play' . $count_sql;
}

function chess_viewtopic_entry()
{
	global $forum_topic_data, $topic_id, $db, $template, $lang, $board_config, $userdata, $is_auth, $phpEx;

	//
	// Does this topic contain a chess game?
	//
	if ( !empty($forum_topic_data['topic_chess']) )
	{
		include('chess_table_select.'.$phpEx);

		$s_hidden_fields = '';

		$chess_info = chess_table_select ( '*', $topic_id, 'Could not obtain chess game data for this topic', 'LIMIT 1' );

		if ( $chess_info )
		{
			$template->set_filenames(array(
				'chessbox' => $board_config['chess_template_path'] . "/" . $board_config['template_name'] . "/chess_viewtopic_body.tpl")
			);

			$chess_set = $board_config['chess_set_path'] . "/" . $chess_info['chess_set_name'];
			include($chess_set . "/set.php");
			$chess_padding_size = 2;
			$chess_player_height = ($chess_board_size * 4) + ($chess_padding_size * 3);

			$chess_board = "";
			$row = explode ( ";", $chess_info['chess_list_position'] );
			$row_num = 8;
			foreach ( $row as $col )
			{
				$col = explode ( ",", $col );
				$col_num = 1;
				$chess_board .= "<tr><td class='notation'>" . $row_num . "</td>";
				foreach ( $col as $piece )
				{
					$nl = chr ( $col_num + 96 );

					$set_piece = "";
					switch ( $piece )
					{
						case 'B' : $set_piece = "<div id='" . $nl . $row_num . "' class='drag'><img src='" . $chess_set . "/b.gif' border='0' title=' " . $nl . $row_num . " ' style='z-index:1;'></div>";break;
						case 'BB' : $set_piece = "<div id='B" . $nl . $row_num . "' class='drag'><img src='" . $chess_set . "/bb.gif' border='0' title=' B" . $nl . $row_num . " ' style='z-index:1;'></div>";break;
						case 'BK' : $set_piece = "<div id='K" . $nl . $row_num . "' class='drag'><img src='" . $chess_set . "/bk.gif' border='0' title=' K" . $nl . $row_num . " ' style='z-index:1;'></div>";break;
						case 'BN' : $set_piece = "<div id='N" . $nl . $row_num . "' class='drag'><img src='" . $chess_set . "/bn.gif' border='0' title=' N" . $nl . $row_num . " ' style='z-index:1;'></div>";break;
						case 'BQ' : $set_piece = "<div id='Q" . $nl . $row_num . "' class='drag'><img src='" . $chess_set . "/bq.gif' border='0' title=' Q" . $nl . $row_num . " ' style='z-index:1;'></div>";break;
						case 'BR' : $set_piece = "<div id='R" . $nl . $row_num . "' class='drag'><img src='" . $chess_set . "/br.gif' border='0' title=' R" . $nl . $row_num . " ' style='z-index:1;'></div>";break;
						case 'W' : $set_piece = "<div id='" . $nl . $row_num . "' class='drag'><img src='" . $chess_set . "/w.gif' border='0' title=' " . $nl . $row_num . " ' style='z-index:1;'></div>";break;
						case 'WB' : $set_piece = "<div id='B" . $nl . $row_num . "' class='drag'><img src='" . $chess_set . "/wb.gif' border='0' title=' B" . $nl . $row_num . " ' style='z-index:1;'></div>";break;
						case 'WK' : $set_piece = "<div id='K" . $nl . $row_num . "' class='drag'><img src='" . $chess_set . "/wk.gif' border='0' title=' K" . $nl . $row_num . " ' style='z-index:1;'></div>";break;
						case 'WN' : $set_piece = "<div id='N" . $nl . $row_num . "' class='drag'><img src='" . $chess_set . "/wn.gif' border='0' title=' N" . $nl . $row_num . " ' style='z-index:1;'></div>";break;
						case 'WQ' : $set_piece = "<div id='Q" . $nl . $row_num . "' class='drag'><img src='" . $chess_set . "/wq.gif' border='0' title=' Q" . $nl . $row_num . " ' style='z-index:1;'></div>";break;
						case 'WR' : $set_piece = "<div id='R" . $nl . $row_num . "' class='drag'><img src='" . $chess_set . "/wr.gif' border='0' title=' R" . $nl . $row_num . " ' style='z-index:1;'></div>";break;
					}

					$chess_board .= "<td class='" . (((8 - $row_num) + ($col_num - 1)) % 2 == 0 ? 'blight' : 'bdark') . "'>" . $set_piece . "</td>\n";
					$col_num++;
				}
				$chess_board .= "</tr>\n";
				$row_num--;
			}

			$chess_board .= "<tr><td class='notation' width='15' height='15'></td>";
			for ( $i = 0; $i < 8; $i++ )
			{
				$chess_board .= "<td class='notation'>" . chr( $i + 97 ) . "</td>";
			}
			$chess_board .= "</tr>";

			$chess_possible = "'" . str_replace( ",", "','", $chess_info['chess_list_valid']) . "'";

			$s_hidden_fields .= '<input type="hidden" name="sid" value="' . $userdata['session_id'] . '" />';

			$chess_user_id = $chess_info['chess_p2_id'] ? ($chess_info['chess_p1_id'] ? $chess_info['chess_p1_id'] . " OR user_id = " . $chess_info['chess_p2_id'] . " LIMIT 2" : $chess_info['chess_p2_id'] . " LIMIT 1") : $chess_info['chess_p1_id'] . " LIMIT 1";

			$sql = "SELECT user_id, username 
				FROM " . USERS_TABLE . " 
				WHERE user_id = $chess_user_id";

			if ( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, "Could not obtain user data for this topic", '', __LINE__, __FILE__, $sql);
			}

			$chess_p1 = $lang['Chess_empty_user'];
			$chess_p2 = $lang['Chess_empty_user'];

			while ( $user_info = $db->sql_fetchrow($result) )
			{
				if ( $user_info['user_id'] == $chess_info['chess_p1_id'] )
				{
					$chess_p1 = $user_info['username'];
				}
				if ( $user_info['user_id'] == $chess_info['chess_p2_id'] )
				{
					$chess_p2 = $user_info['username'];
				}
			}
			$db->sql_freeresult($result);

			$chess_list_move = explode( '|', $chess_info['chess_list_move'] );
			$chess_white_list = "";
			$chess_black_list = "";

			if($chess_list_move[0]!="")
			{
				$chess_list_move[0] = explode( ';', $chess_list_move[0] );
				foreach ( $chess_list_move[0] as $line )
				{
					$line = explode( ',', $line );
					$chess_white_list .= "<span title='" . date( "r", $line[0] ) . "'>" . $line[1] . "</span><br>\n";
				}
			}
			if($chess_list_move[1]!="")
			{
				$chess_list_move[1] = explode( ';', $chess_list_move[1] );
				foreach ( $chess_list_move[1] as $line )
				{
					$line = explode( ',', $line );
					$chess_black_list .= "<span title='" . date( "r", $line[0] ) . "'>" . $line[1] . "</span><br>\n";
				}
			}

//
// *** added by Zlodey (for Chess+) ***
$razmer_stavki = (!$chess_info['stavka_fb'] AND !$chess_info['stavka_or']) ? (" ( )") : (" ( " . $chess_info['stavka_fb'] . " " . $board_config['points_name'] . " / " . $chess_info['stavka_or'] . " ..)");
// *** added by Zlodey (for Chess+) ***
//

			$template->assign_vars(array(
				'S_CHESS_BOARD_SIZE' => $chess_board_size,
				'S_CHESS_PADDING_SIZE' => $chess_padding_size,
				'S_CHESS_NOTATION_SIZE' => $chess_notation_size,
				'S_CHESS_PLAYER_HEIGHT' => $chess_player_height,

//
// *** added by Zlodey (for Chess+) ***
	'RAZMER_STAVKI' => $razmer_stavki,
// *** added by Zlodey (for Chess+) ***
//

				'S_CHESS_P1' => $chess_p1,
				'S_CHESS_P2' => $chess_p2,
				'L_CHESS_SIDE' => $lang['Chess_side'],
				'L_CHESS_WHITE' => $lang['Chess_white'],
				'L_CHESS_BLACK' => $lang['Chess_black'],

				'L_CHESS_MOVE_LIST' => $lang['Chess_move_list'],
				'S_CHESS_WHITE_MOVE_LIST' => $chess_white_list,
				'S_CHESS_BLACK_MOVE_LIST' => $chess_black_list,

				'S_CHESS_BOARD_NAME' => $board_config['chess_board_path'] . "/" . $chess_info['chess_board_name'] . "/",
				'CHESS_BOARD' => $chess_board)
			);

			if ( $chess_info['chess_p1_id'] == 0 || $chess_info['chess_p2_id'] == 0 )
			{
				$template->assign_vars(array(
					'S_CHESS_MESSAGE' => $chess_info['chess_message'])
				);

				$template->assign_block_vars('chess_wait', array());

			}

			if ( (($chess_info['chess_p1_id'] == 0 && $userdata['user_id'] != $chess_info['chess_p2_id']) || ($chess_info['chess_p2_id'] == 0 && $userdata['user_id'] != $chess_info['chess_p1_id'])) && $is_auth['auth_chess_play'] )
			{
				$template->assign_vars(array(
					'S_CHESS_ACTION' => append_sid("posting.$phpEx?mode=chess_join&amp;" . POST_TOPIC_URL . "=$topic_id"),

					'L_CHESS_PREF' => $lang['Chess_position'],
					'L_CHESS_BOTTOM' => $lang['Chess_bottom'],
					'L_CHESS_TOP' => $lang['Chess_top'],
					'L_CHESS_JOIN' => $lang['Chess_join'],

					'S_HIDDEN_FIELDS' => $s_hidden_fields)
				);

				$template->assign_block_vars('chess_join', array());
			}
			else if ( $chess_info['chess_p1_id'] != 0 && $chess_info['chess_p2_id'] != 0 && $userdata['user_id'] == $chess_info['chess_turn'] && $is_auth['auth_chess_play'] )
			{
				$template->assign_vars(array(
					'S_CHESS_JS' => $board_config['chess_include_path'] . "/",
					'CHESS_POSSIBLE_MOVE' => $chess_possible,
					'S_CHESS_LIST_ID' => ($userdata['user_id'] == $chess_info['chess_p1_id']) ? "chess_white_list" : "chess_black_list",

					'L_CHESS_ALERT_MOVE_01' => $lang['Chess_alert_move_01'],
					'L_CHESS_ALERT_MOVE_02' => $lang['Chess_alert_move_02'],

					'S_CHESS_ACTION' => append_sid("posting.$phpEx?mode=chess_play&amp;" . POST_TOPIC_URL . "=$topic_id"),

// *** added by Zlodey (for Chess) ***
					'S_PIPEZ_ACTION' => append_sid("posting.$phpEx?mode=pipez&amp;" . POST_TOPIC_URL . "=$topic_id"),
					'S_NICH_ACTION' => append_sid("posting.$phpEx?mode=nich&amp;" . POST_TOPIC_URL . "=$topic_id"),
// *** added by Zlodey (for Chess) ***

					'L_CHESS_NOTATION' => $lang['Chess_notation'],
					'L_CHESS_RESET' => $lang['Chess_reset'],
					'L_CHESS_SUBMIT' => $lang['Chess_submit'],
					'L_CHESS_NOTIFICATION' => $lang['Chess_notification'],

					'S_HIDDEN_FIELDS' => $s_hidden_fields)
				);

				$template->assign_block_vars('chess_play', array());
			}

			$template->assign_var_from_handle('CHESS_DISPLAY', 'chessbox');
		}
	}
}
?>